##### Activity
# Simulate the Internet

### AP Computer Science Principles: Learning Objectives:

- [LO 2.3.1] Use models and simulations to represent phenomena. [P3]
- [LO 6.1.1] Explain the abstractions in the Internet and how the Internet functions. [P3]
- [LO 6.2.1] Explain characteristics of the Internet and the systems built on it. [P5]
- [LO 6.2.2] Explain how the characteristics of the Internet influence the systems built on it. [P4]
- [LO 6.3.1] Identify existing cybersecurity concerns and potential options to address these issues with the Internet and the systems built on it. [P1]
 
## What is packet transfer?
 
Packet transfer is a way of moving data through the Internet. It involves breaking up the data into smaller pieces, called packets, when sending it over a network.
 
#### What you need:
- A shape made out of Legos, or something else that can be broken into smaller pieces. A piece of paper with a written message or image would also work.
 
Students will participate in a whole-class interactive activity to simulate the secure transfer of data across the internet. Each student will research the role of a different component or device then simulate the part as assigned. These components in particular could be included:

* A client (a person’s computer or mobile phone, for example)
* A wifi router at home
* A cable modem at home
* Multiple internet routers
* A load balancing server
* Multiple servers providing a service or website

The whole class will work together to deliver the teacher-made packet to be delivered and assembled into a message. Have students take turns presenting a summary of what they learned about their component and how it works. Then lead the students in acting out the behavior of their chosen component to simulate how a packet travels through the system. For example:

* The client tosses the message to the wifi router
* The wifi router hands the packet to the cable modem through a cardboard tube that says ethernet
* The cable modem hands the packet to an internet router through a cardboard tube that says TV cable
* The router decides between two other routers to send to based on who got the last packet.
* The load balancer gets all messages and then decides which web server to receive the message and then always passes messages to that server for that message.

At the end of the activity, students will write a short summary of the simulation and analyze how well it represented the Internet, answering the assessment questions below.

### Assessment Questions:
* How well did the class’s simulation represent the actual process? [LO 2.3.1]
* Explain in your own words how packet processing works. [EK 6.2.2F]
* How did the class handle security? What vulnerabilities are there still? How could you address them? [LO 6.3.1]
